
#include "stdafx.h"
#include "lex.h"
#include "symbol.h"

ifstream soubor;

// funkce pro nacteni jednoho znaku ze vstupu, vcetne kontroly konce souboru, konce radku, pocitani radku:
char nacti_znak() {
	while (1) {
		if (soubor.eof()) {
			vstup.konec = 1;
			vstup.c = '\0';
			break;
		}
		soubor.get(vstup.c);
		//		cout << "nacten " << vstup.c << endl;
		if (vstup.c == '\n') {
			vstup.rad++;
			vstup.pozice = 0;  // pristi cyklus while najde prvni znak na radku
//			cout << "konec radku, novy: " << vstup.rad << endl;
		}
		else {
			vstup.pozice++;
			//			cout << vstup.pozice;
			break;
		}
	}
	return vstup.c;
}
// cely radek: http://stackoverflow.com/questions/23726724/reading-string-by-char-till-end-of-line-c-c


// tato funkce rozlisuje jednotliva klicova slova:
void klicove_slovo(string v) {
	int delka;
	int stav = 0;
	const int k_error = 13, k_var = 14, k_cti = 15, k_pis = 16, k_proc = 17;

	delka = v.size();
	// podle prechodove tabulky pro slova VAR, CTI, PIS, PROCENTA:
	for (int i = 0; i < delka; i++) {
		if (stav >= k_error) break;
		switch (stav) {
		case 0:
			switch (v[i]) {
			case 'v': stav = 1; break;
			case 'c': stav = 3; break;
			case 'p': stav = 5; break;
			default: stav = k_error;
			}
			break;
		case 1:
			if (v[i] == 'a') stav = 2; else stav = k_error;
			break;
		case 2:
			if (v[i] == 'r') stav = k_var; else stav = k_error;
			break;
		case 3:
			if (v[i] == 't') stav = 4; else stav = k_error;
			break;
		case 4:
			if (v[i] == 'i') stav = k_cti; else stav = k_error;
			break;
		case 5:
			if (v[i] == 'i') stav = 6; else stav = k_error;
			break;
		case 6:
			if (v[i] == 's') stav = k_pis; else stav = k_error;
			break;
		case 7:
			if (v[i] == 'o') stav = 8; else stav = k_error;
			break;
		case 8:
			if (v[i] == 'c') stav = 9; else stav = k_error;
			break;
		case 9:
			if (v[i] == 'e') stav = 10; else stav = k_error;
			break;
		case 10:
			if (v[i] == 'n') stav = 11; else stav = k_error;
			break;
		case 11:
			if (v[i] == 't') stav = 12; else stav = k_error;
			break;
		case 12:
			if (v[i] == 'a') stav = k_proc; else stav = k_error;
			break;
		default: stav = k_error;
		}
	}
	switch (stav) {
	case k_var: symbol.typ = S_var; break;
	case k_cti: symbol.typ = S_cti; break;
	case k_pis: symbol.typ = S_pis; break;
	case k_proc: symbol.typ = S_procenta;
	} // jinak by slo o promennou
}


// funkce rozpoznavajici jeden symbol ze vstupu, vysledek nacte do promenne symbol:
int lex() {
	symbol.typ = S_nic; // inicialni hodnota - zatim nevime

	while ((!vstup.konec) && (isspace(vstup.c))) // preskocime prazdne znaky (mezery, tabulatory apod.)
		nacti_znak();
	
	if (vstup.konec) {
		symbol.typ = S_endoffile;
	}

	else if ((isalpha(vstup.c) || vstup.c == '_')) {		// pokud je prvnim znakem symbolu pismeno nebo podtrzitko, bude to S_id
		symbol.atribstr = vstup.c;
		nacti_znak();
		while ((!vstup.konec) && ((isalnum(vstup.c)) || (vstup.c == '_'))) {
			symbol.atribstr += vstup.c;
			nacti_znak();
		}
		symbol.typ = S_id;
		klicove_slovo(symbol.atribstr);
	} 

	else if (isdigit(vstup.c)) {			// pokud je prvnim znakem symbolu cislice, bude to cislo
		symbol.atribInt = (int)vstup.c - 48;
		nacti_znak();
		while ((!vstup.konec) && (isdigit(vstup.c))) {
			symbol.atribInt = symbol.atribInt * 10 + (int)vstup.c - 48;
			nacti_znak();
		}
		if (isalpha(vstup.c)) {
			vypis_chybu("Nazev promenne nemuze zacinat cislici -- ");
			cout << symbol.atribInt << vstup.c;
		} 
		else 
		symbol.typ = S_cislo;
	} 
	
	else {						// jinak...
		switch (vstup.c) {
		case '+':
			symbol.typ = S_plus;
			break;
		case '-':
			symbol.typ = S_minus;
			break;
		case '*':
			symbol.typ = S_krat;
			break;
		case '/':
			symbol.typ = S_deleno;
			break;
		case '=':
			symbol.typ = S_prirad;
			break;
		case '(':
			symbol.typ = S_lzav;
			break;
		case ')':
			symbol.typ = S_rzav;
			break;
		case ';':
			symbol.typ = S_strednik;
			break;
		case ',':
			symbol.typ = S_carka;
			break;
		case '{':
			symbol.typ = S_begin;
			break;
		case '}':
			symbol.typ = S_end;
			break;
		default:				// nic znameho
//			symbol.typ = S_nic;
			vypis_chybu("Neidentifikovatelny symbol - znak: " + string(1, vstup.c));
			return 1;
		}
		nacti_znak();
	}

	return 0;
}


// inicializace lexikalni analyzy:
int inicializace_lex() {
	nazevsouboru = "vstup.txt";
	soubor.open(nazevsouboru);
	if (!soubor.is_open()) {
		std::cerr << "Vstupni soubor se nepodarilo otevrit -- musi to byt soubor vstup.txt tam, kde je exe soubor.\n";
		vstup.konec = 1;
		return 1;
	}
	vstup.c = '\0';
	vstup.rad = 1;
	vstup.konec = 0;
	soubor.get(vstup.c);
	return 0;
}

void ukonceni_lex() {
	soubor.close();
}


void lexikalni_analyza() {
	while (!vstup.konec) {
		lex();
		if (!((vstup.konec)&&(symbol.typ == S_nic))) {
			cout << vypis_symbol(symbol.typ);
			if (symbol.typ == S_cislo) {
				cout << ' ' << symbol.atribInt;
			}
			else if (symbol.typ == S_id) {
				cout << ' ' << symbol.atribstr;
			}
			cout << endl;
		}
	}
}